Subject: [PATCH net RESEND] bonding: add ip checks when store ip target

From: Ding Tianhong <[email-masked]>
Date: Wed, 13 Nov 2013 10:19:02 +0800

I met a Bug when I add ip target with the wrong ip address:

echo +500.500.500.500 > /sys/class/net/bond0/bonding/arp_ip_target

the wrong ip address will transfor to 245.245.245.244 and add
to the ip target success, it is uncorrect, so I add checks to avoid
adding wrong address.

The in4_pton() will set wrong ip address to 0.0.0.0, it will return by
the next check and will not add to ip target.

Signed-off-by: Ding Tianhong <[email-masked]>
---
 drivers/net/bonding/bond_sysfs.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

diff --git a/drivers/net/bonding/bond_sysfs.c b/drivers/net/bonding/bond_sysfs.c
index ec9b646..e0c97fb 100644
--- a/drivers/net/bonding/bond_sysfs.c
+++ b/drivers/net/bonding/bond_sysfs.c
@@ -653,7 +653,7 @@ static ssize_t bonding_store_arp_targets(struct device *d,
 	int ind, i, j, ret = -EINVAL;
 
 	targets = bond->params.arp_targets;
-	newtarget = in_aton(buf + 1);
+	in4_pton(buf + 1, strlen(buf) - 1, (u8 *)&newtarget, -1, NULL);
 	/* look for adds */
 	if (buf[0] == '+') {
 		if ((newtarget == 0) || (newtarget == htonl(INADDR_BROADCAST))) {
-- 
1.8.0